// Head for FRobot.pov

#ifndef(Get) 
 #include "colors.inc"
  global_settings{assumed_gamma 1.0  
                 max_trace_level 50 }
 camera{ location <5,0,-5>
        right x*image_width/image_height
        look_at <0,1,-1>
        }
 background{Pink}
 light_source{ <-200,0,0> color White}
 light_source{ <200,30,-30> color White}
 light_source{ <40,200,-300> color White}
 light_source{ <-60,100,-20> color White}
 //light_source{ <0,-100,0> color White}
 //light_source{ <0,0,200> color White}
 plane{y,-5 pigment{Green}}
 #declare Facefile="Fron1.txt";// composition POSE
 // read old files
 #fopen Mfile Facefile read
  #read (Mfile EyeLA)
  #read (Mfile Puple)
  #read (Mfile Leyeu)
  #read (Mfile Leyel)
  #read (Mfile Reyeu)
  #read (Mfile Reyel)
  #read (Mfile Lm1)
  #read (Mfile Lm2)
  #read (Mfile Lm3)
  #read (Mfile Lm4)
  #read (Mfile Lm5)
 #fclose Mfile
#declare Ep=pigment{gradient z color_map{[.5 White*.6][.5 Clear]}}
#declare Etex=
 texture{pigment{rgb <0,0,.6>}finish{reflection .1 specular .25}}
 texture{pigment{gradient z color_map{[.5 White*.6][.5 Clear]}}
  }

#declare Pr=.97+(1-.98)*(1-Puple);
#declare Etex2=
 texture{pigment{cylindrical 
  color_map{[.95 White][.95 rgb <0,0,.6>]
            [Pr rgb <.2,.2,.9>][Pr Black]}
  rotate x*90}
  finish{reflection .1 specular 1 roughness .001}}
#declare Mtex=// main body texture {pigment{White*.6}}              
        texture{pigment{Blue}
        normal {facets size.03}
        finish {
    ambient 0.3
    brilliance 2
    diffuse 0.5
    metallic
    specular 0.80
    roughness 1/20
    //reflection 0.1
     }}

#declare Htex=texture {pigment{White*.4}}// hand texture {pigment{white*.4}}       
#declare Ertex=texture {pigment{White*.4}} // ear texture {pigment{white*.4}}                
#declare Mp=pigment{checker  White*.1 White*.6 
     scale<.02,.04,.04>}

#end

/*/------variables---------
#declare EyeLA=<0,0,0>; //<+-20,+-20,0> Eye look at
#declare Puple=.25;//0=<Puple=<1
#declare Leyeu=30;//0 to 60 left upper eyelid
#declare Leyel=-30;//0 to -60  left lower eyelid
#declare Reyeu=28;//0 to 60 Right upper eyelid
#declare Reyel=-30;//0 to -60  Right lower eyelid

#declare Lm1=.1;//+-.1
#declare Lm2=.025;
#declare Lm3=.0;
#declare Lm4=.025;
#declare Lm5=.1;
#end
----Faces-----------
sad -.08,.01,.02,.01,-.08
smile .1,.025,0,.025,.1
mad 0,.025,0,.025,0
*/
//---------------------------


#declare Head=
union{
 ///skull
 torus{.5,.25 rotate z*90}
 cylinder{-x*.25,x*.25,.5}

// jaw
// cone{-z*.5,.25 <0,-.7,-.6>,.2}
 cone{-z*.5,.26 <0,-.7,-.6>,.2}
 cylinder{<0,-.7,-.3>,<0,-.7,-.6>,.2}
 sphere{<0,-.7,-.6>,.2 }
 sphere{<0,-.7,-.25>,.2}
 cone{<0,-.7,-.25>,.2,<0,0,-.1>,.25}
//nose
 cone{<0,.25,-.6>,.13,<0,-.3,-.75>,.15 scale<.5,1,1>}
// mouth
/*
 union{
 cylinder{<0,0,-.20>,<0,0,0>,.2  scale<.5,Ma,1> pigment{Mp}}
 torus{.19,.03 rotate x*90 translate<0,0,-.17>  scale<.5,Ma,1> }
 cylinder{<0,0,-.19>,<0,0,0>,.22  scale<.5,Ma,1> }
 translate x*Mc rotate Mr*z
 translate <0,-.55,-.6>}
*/
#declare Lip=union{
 torus{.19,.03 rotate x*90 translate<0,0,-.2> pigment{Red*.5}}
  cylinder{<0,0,-.21>,<0,0,0>,.2 pigment{Mp scale 2}}//texture{Ertex}}
 cylinder{<0,0,-.2>,<0,0,0>,.22 }
 scale <.5,1,1>*.3}

object{Lip scale .75 translate <-.12,-.55+Lm1,-.72>}
object{Lip scale .85 translate <-.065,-.55+Lm2,-.74>}
object{Lip translate <0,-.55+Lm3,-.75>}
object{Lip scale .85 translate <.065,-.55+Lm4,-.74>}
object{Lip scale .75 translate <.12,-.55+Lm5,-.72>}
 
// eyes
 union{
 cone{<.0,.1,0>,.2 <.0,.1,-.6>,.4 }
  cylinder{<.0,.1,-.6>, <.0,.1,-.7>,.4 }
  torus{.37,.03 rotate x*90 translate<.0,.1,-.7>}
  cylinder{<.0,.1,-.69>, <.0,.1,-.73>,.37 }
  //sphere{<0,.4,-.73>,.025 scale<.5,1,1>}
  translate -z*.02}
union{
 torus{.12,.03 rotate x*90 translate<-.23,.1,-.73> scale<.9,1.2,1>}
 sphere{<-.23,.1,-.73>,.1 
  texture{Etex2 rotate EyeLA translate<-.23,.1,-.73>}scale<.9,1.2,1>}
 intersection{sphere{0,.12}
              box{<-.5,0,-.5>,<.5,.5,.5>}
              rotate x*(Leyeu+1)
              translate <-.23,.1,-.73> scale<.9,1.2,1>}
 intersection{sphere{0,.12}
              box{<-.5,0,-.5>,<.5,-.5,.5>}
              rotate x*(Leyel-1)
              translate <-.23,.1,-.73> scale<.9,1.2,1>}
 intersection{sphere{0,.12}
              box{<-.5,0,-.5>,<.5,.5,.5>}
              rotate x*(Reyeu+1)
              translate <.23,.1,-.73> scale<.9,1.2,1>}
 intersection{sphere{0,.12}
              box{<-.5,0,-.5>,<.5,-.5,.5>}
              rotate x*(Reyel-1)
              translate <.23,.1,-.73> scale<.9,1.2,1>}

 torus{.12,.03 rotate x*90 translate<.23,.1,-.73> scale<.9,1.2,1>}
 sphere{<.23,.1,-.73>,.1 
  texture{Etex2 rotate EyeLA translate<.23,.1,-.73>}scale<.9,1.2,1>}
 scale<1,1.25,1> 
 translate -y*.1
 }

// ears
 union{
 cone{<.25,-.1,.1>,.1,<.35,-.1,.1>,.2 open scale<1,1.2,.75> }
  sphere{<.25,-.1,.1>,.1 scale<.85,1.2,.75> }
 cone{<-.25,-.1,.1>,.1,<-.35,-.1,.1>,.2 open scale<1,1.2,.75>}
  sphere{<-.25,-.1,.1>,.1 scale<.85,1.2,.75> }
 texture{Ertex}}
 
texture{Mtex}

scale<2,1,1>
translate <0,.75,0>// puts the heads base at 0
}
#ifndef(Get)
 object{Head}
#end 